unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms,
  Buttons, Menus, IniFiles, StdCtrls, Controls, ShellApi, iChii;

const
    WM_NotifyTasktray = WM_APP + 100;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuMisc: TMenuItem;
    MenuInfo: TMenuItem;
    MenuExit: TMenuItem;
    MenuConfig: TMenuItem;
    PopupMenu: TPopupMenu;
    Config1: TMenuItem;
    Info1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Show1: TMenuItem;
    N2: TMenuItem;
    Cancel1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuConfigClick(Sender: TObject);
    procedure Show1Click(Sender: TObject);
  private
    FIniFile    : TIniFile;

    IsLiveTasktray: boolean;
    NotifyIcon  : TNotifyIconData;
    procedure   InitTasktray;
    procedure   FinishTasktray;

    procedure   MessageOut(AMsg: string);
    procedure   SetMessageOut();
  protected
    procedure   TrayMessage(var Msg: TMsg); message WM_NotifyTasktray;  
  public
    constructor Create(AOwner: TComponent); override;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    Info, Config;

(*
    ===========================================================================
    bZ[W\
    ===========================================================================
*)
procedure TMainForm.MessageOut(AMsg: string);
begin
    if (Memo1.Lines.Count > 200) then Memo1.Lines.Clear();
    Memo1.Lines.Add(AMsg);
end;

(*
    ===========================================================================
    bZ[W\
    ===========================================================================
*)
procedure   TMainForm.SetMessageOut();
begin
    if (iChii.MSG_OUT_LEVEL = 0) then
    begin
        iChii.MSG_OUT_LVL_1 := nil;
        iChii.MSG_OUT_LVL_2 := nil;
    end
    else
    if (iChii.MSG_OUT_LEVEL = 1) then
    begin
        iChii.MSG_OUT_LVL_1 := MessageOut;
        iChii.MSG_OUT_LVL_2 := nil;
    end
    else
    begin
        iChii.MSG_OUT_LVL_1 := MessageOut;
        iChii.MSG_OUT_LVL_2 := MessageOut;
    end;
end;

(*
    ===========================================================================
    j[/I
    ===========================================================================
*)
procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close;
end;

(*
    ===========================================================================
    j[/
    ===========================================================================
*)
procedure TMainForm.MenuInfoClick(Sender: TObject);
begin
    OpenInfoForm();
end;

(*
    ===========================================================================
    j[/ݒ
    ===========================================================================
*)
procedure TMainForm.MenuConfigClick(Sender: TObject);
begin
    OpenConfigForm();
    SetMessageOut();
end;

(*
    ===========================================================================
    |bvAbvj[/\
    ===========================================================================
*)
procedure TMainForm.Show1Click(Sender: TObject);
begin
    Show;
end;

(*
    ===========================================================================
    tH[RXgN^
    ---------------------------------------------------------------------------
    http://www.apionet.or.jp/~tubokura/k_tips.html
    ===========================================================================
*)
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  ^XNgCɈړ
    Application.ShowMainForm := False;
    InitTaskTray;

    //  ^XNo[ɕ\Ȃ
    ShowWindow(Application.Handle, SW_HIDE);

    ClickHere := TClickHereItIs.Create();

    //  ݒt@CǍ
    FIniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //  tH_
    DESKTOP_STR := FIniFile.ReadString('ClickHere', 'Desktop', DESKTOP_STR);
    MYCOMPUTER_STR := FIniFile.ReadString('ClickHere', 'MyComputer', MYCOMPUTER_STR);
    MYNETWORK_STR := FIniFile.ReadString('ClickHere', 'MyNetwork', MYNETWORK_STR);
    //  ҂Ԑݒ
    WAIT_FOR_CHECK := FIniFile.ReadInteger('ClickHere', 'WaitForCheck', WAIT_FOR_CHECK);
    WAIT_FOR_OK    := FIniFile.ReadInteger('ClickHere', 'WaitForOK', WAIT_FOR_OK);
    //  Ox
    MSG_OUT_LEVEL  := FIniFile.ReadInteger('ClickHere', 'LogLevel', MSG_OUT_LEVEL);
    SetMessageOut();

    ClickHere.Start;
end;

(*
    ===========================================================================
    tH[fXgN^
    ===========================================================================
*)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  ^XNgCEo
    FinishTasktray;

    ClickHere.Stop;
    ClickHere.Free;

    //  tH_ۑ
    FIniFile.WriteString('ClickHere', 'Desktop', DESKTOP_STR);
    FIniFile.WriteString('ClickHere', 'MyComputer', MYCOMPUTER_STR);
    FIniFile.WriteString('ClickHere', 'MyNetwork', MYNETWORK_STR);
    //  ҂ԕۑ
    FIniFile.WriteInteger('ClickHere', 'WaitForCheck', WAIT_FOR_CHECK);
    FIniFile.WriteInteger('ClickHere', 'WaitForOK', WAIT_FOR_OK);
    //  Oxۑ
    FIniFile.WriteInteger('ClickHere', 'LogLevel', MSG_OUT_LEVEL);

    FIniFile.Free;
end;



(*
    ===========================================================================
    RXgN^
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    ===========================================================================
*)
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited;
    IsLiveTaskTray := False;
end;

(*
    ===========================================================================
    EBhEbZ[W
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    http://www.wwlnk.com/boheme/delphi/tips/tec0310.htm
    http://www.tls.org/~akiraand/tech_01.html
    ===========================================================================
*)
procedure   TMainForm.TrayMessage(var Msg: TMsg);
begin
    SetForegroundWindow(Handle);
    case Msg.wParam of
        WM_LBUTTONDOWN,
        WM_RBUTTONDOWN: PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
    end;
end;

(*
    ===========================================================================
    ^XNgCɃZbg
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    ===========================================================================
*)
procedure TMainForm.InitTasktray;
begin
    //  Ƀ^XNgCȂXLbv
    if IsLiveTasktray then exit;
    //  \̏
    FillChar(NotifyIcon, SizeOf(NotifyIcon), #0);
    with NotifyIcon do
    begin
        cbSize := SizeOf(TNotifyIconData);
        Wnd    := Handle;
        uID    := 1;
        uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        uCallbackMessage := WM_NotifyTasktray;
        hIcon  := Application.Icon.Handle;
    end;
    //  `bvwvݒ
    StrPLCopy(NotifyIcon.szTip, ExtractFileName(Application.ExeName), 64);
    //  ǉ
    Shell_NotifyIcon(NIM_ADD, @NotifyIcon);
    //  tOON
    IsLiveTasktray := True;
end;

(*
    ===========================================================================
    ^XNgC
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    ===========================================================================
*)
procedure TMainForm.FinishTasktray;
begin
    //  Ƀ^XNgCɂȂȂXLbv
    if not IsLiveTasktray then exit;
    //  \̏
    with NotifyIcon do
    begin
        cbSize := SizeOf(TNotifyIconData);
        Wnd := Handle;
        uID := 1;
    end;
    //  폜
    Shell_NotifyIcon(NIM_DELETE, @NotifyIcon);
    //  tOOFF
    IsLiveTasktray := False;
end;

end.

